from time import sleep
from netgen.geom2d import SplineGeometry
from netgen.meshing import MeshingParameters
from ngsolve import *                               
from xfem import *
# For LevelSetAdaptationMachinery
from xfem.lsetcurv import *

# Geometry 
square = SplineGeometry()
square.AddRectangle([-1.5,-1.5],[1.5,1.5],bc=1)

#quad version:
ngmesh = square.GenerateMesh(maxh=0.15, quad_dominated=True)
mesh = Mesh (ngmesh)


#Boundary with Level set method
R=1.#Circle's  radious
levelset = sqrt(x*x+y*y) - R

Vh = H1(mesh, order = 1)  
mesh.GetBoundaries()

lsetmeshadap = LevelSetMeshAdaptation(mesh, order=1, threshold=0.1, discontinuous_qn=True)
deformation = lsetmeshadap.CalcDeformation(levelset)
lsetp1 = lsetmeshadap.lset_p1

lset_neg = { "levelset" : lsetp1, "domain_type" : NEG, "subdivlvl" : 0}

ci = CutInfo(mesh,lsetp1)
hasneg = BitArray(ci.GetElementsOfType(NEG))

active_dofs = GetDofsOfElements(Vh,hasneg)
active_dofs &= Vh.FreeDofs()

NEGMesh=BitArrayCF(hasneg)
#NEGMesh.GetBoundaries()#It is not working
Draw(NEGMesh, mesh,"NEG")#Working fine
           
a = BilinearForm(Vh,symmetric=False)
            
u,v = Vh.TrialFunction(), Vh.TestFunction()
 
#VhNEG = H1(NEGMesh, order = 1) #It is not working

# Diffusion term
a += SymbolicBFI(lset_neg,form = u*v)#Working fine
a += SymbolicBFI(lset_neg,form = u*v, skeleton=True, definedon=NEGMesh.Boundaries())#It is not working
